import ads;

real D = 1.7;
real R = 1.2;
real L = 0.6;

real dd[] = { 150, 30, -90 };

pair c[];
pair v[];
for (int i=0; i<3; ++i) {
	pair d = dir(dd[i]);
	c[i] = D*d;
	draw(circle(c[i], R), shortdashed);
	v[2*i] = c[i] + L*dir(-150)*d;
	v[2*i+1] = c[i] + L*dir(150)*d;
	label("$x_" + (string)(i+1) + "$", v[2*i], 1.7*dir(-90)*d);
	label("$y_" + (string)(1+(i+2)%3) + "$", v[2*i+1], 1.7*dir(90)*d);
};

label("$C_1$", c[0] + 1.05*D*WNW);
label("$C_2$", c[1] + 1.05*D*ENE);
label("$C_3$", c[2] + 1.05*D*WSW);

vertex_size = 0.1;
graph(v, 1);

arc(0, 3);
arc(2, 5);
arc(4, 1);

void walk(int i, int src, int dst)
{
	pair sr = v[src], ds = v[dst];
	pair d = dir(dd[i]);
	pair sd = dir(30)*d, dd = dir(150)*d;
	draw(sr + vertex_size*sd {sd}.. c[i] + 0.6*R*d .. {dd} ds - vertex_size*dd, dashed, e_arrow);
}

walk(0, 1, 0);
walk(1, 3, 2);
walk(2, 5, 4);
