import ads;

/*
 *	stred: 0
 *	vnitrni cyklus: 1-5
 *	vnejsi cyklus: 6-10
 */

vertex_size = 0.2;

pair v[] = { (0,0) };
for (int i=0; i<5; ++i)
	v.push(2*dir(72*i + 18));
for (int i=0; i<5; ++i)
	v.push(4*dir(72*i + 18));
int n = v.length;

int edges[][] = {
//	odkud	kam	délka	směr popisky
	{ 0,	1,	1,	0 },
	{ 0,	2,	7,	0 },
	{ 0,	3,	3,	0 },
	{ 0,	4,	9,	0 },
	{ 0,	5,	8,	0 },
	{ 1,	2,	1,	0 },
	{ 2,	3,	5,	0 },
	{ 3,	4,	7,	0 },
	{ 4,	5,	2,	0 },
	{ 5,	1,	5,	0 },
	{ 1,	6,	1,	0 },
	{ 2,	7,	3,	0 },
	{ 3,	8,	7,	0 },
	{ 4,	9,	9,	0 },
	{ 5,	10,	1,	0 },
	{ 6,	7,	2,	0 },
	{ 7,	8,	1,	0 },
	{ 8,	9,	1,	0 },
	{ 9,	10,	5,	0 },
	{ 10,	6,	0,	0 },
};

int dist[] = { 0 };
int pred[] = { -1 };
for (int i=1; i<n; ++i) {
	dist[i] = 10000;
	pred[i] = -1;
}
for (int i=0; i<n; ++i) {
	for (int [] e: edges) {
		int u = e[0], v = e[1], d = e[2];
		if (dist[v] > dist[u] + d) {
			dist[v] = dist[u] + d;
			pred[v] = u;
		} else if (dist[u] > dist[v] + d) {
			dist[u] = dist[v] + d;
			pred[u] = v;
		}
	}
}

graph(v, v_white);

for (int i=0; i<n; ++i)
	label("\eightrm " + string(dist[i]), v[i]);

for (int [] e: edges) {
	int x = e[0], y = e[1], d = e[2];
	if (x == pred[y])
		arc(x, y, thick);
	else if (y == pred[x])
		arc(y, x, thick);
	else
		edge(x, y);
	label("\eightrm " + string(d), interp(v[x], v[y], 0.5), 1.5 * unit(v[x]-v[y]) * dir(90));
}
