import ads;

/*
 *	a-40-->c--15-->d
 *	|      ^
 *	30     |
 *	|      |
 *	v      |
 *	b--50--+
 */

real u = 1;

pair a = (-0.5,1)*u;
pair b = (-2,-2)*u;
pair c = (3,-1)*u;
pair d = (5,-1)*u;

vertex(a);	label("$a$", a, 1.2 WNW);
vertex(b);	label("$b$", b, 1.2 NW);
vertex(c);	label("$c$", c, 1.5 SSE);
vertex(d);	label("$d$", d, 1.2 NE);

void se(pair x, pair y, int l)
{
	edge(x, y);
	pair d = unit(y-x) / 20;
	for (int i=1; i<l; ++i) {
		real t = i/l;
		pair p = interp(x, y, t);
		draw(p+d*dir(90) -- p+d*dir(-90));
	}
}

se(a, c, 40);	label("$40$", interp(a, c, .7), 1.3 NNE);
se(a, b, 30);	label("$30$", interp(a, b, .6), 1.3 NW);
se(b, c, 50);	label("$50$", (b+c)/2, 1.3 SE);
se(c, d, 15);	label("$15$", (c+d)/2, 1.5 N);

pair p1 = interp(a, c, 10/40);
pair q1 = interp(a, b, 10/30);
pair pp1 = p1 + unit(c-a)*dir(60)/3;
pair qq1 = q1 + unit(b-a)*dir(-60)/2;
draw(pp1 .. p1 .. q1 .. qq1, shortdashed);

pair p2 = interp(a, c, 20/40);
pair q2 = interp(a, b, 20/30);
pair pp2 = p2 + unit(c-a)*dir(60)/3;
pair qq2 = q2 + unit(b-a)*dir(-50)/2;
draw(pp2 .. p2 .. q2 .. qq2, shortdashed);

pair p3 = interp(a, c, 35/40);
pair q3 = interp(b, c, 5/50);
pair pp3 = p3 + unit(c-a)*dir(50)/2;
pair qq3 = q3 + unit(b-c)*dir(30)/2;
draw(pp3 .. p3 .. q3 .. {curl 2} qq3, shortdashed);
