import ads;
import graph;

real aspect = 0.5;
size(100mm, 100mm*aspect, IgnoreAspect);

real f(real x) { return log(x) / log(2); }

xaxis("$x$", xmin=0, xmax=20);
yaxis("$y$", ymin=0, ymax=5);
draw(graph(f, 1, 20));

real a = 1.5;
real b = 18;
real c = (a+b)/2;
pair aa = (a, f(a));
pair bb = (b, f(b));
pair cc = (aa + bb)/2;
pair dd = (c, f(c));

void pt(pair x)
{
	fill(shift(x) * scale(0.1, 0.1*aspect) * unitcircle);
}

pt(aa);
pt(bb);
pt(cc);
pt(dd);
draw(aa -- bb, halfthick);
draw((c,0) -- (c,f(c)+1), dotted);

label("$A=(\alpha,f(\alpha))$", aa, SE);
label("$B=(\beta,f(\beta))$", bb, 2*dir(-55));
label("$S'=\left({\alpha+\beta\over 2},f\!\left({\alpha+\beta\over 2}\right)\right)$", dd, 3*dir(140));
label("$S=\left({\alpha+\beta\over 2},{f(\alpha)+f(\beta)\over 2}\right)$", cc, 2*dir(-35));
