import ads;
import trees;

// Strom

real width = 2.5;
real spread = 1;
pair t[];
t[0] = (0,0);
for (int i=0; i<4; ++i) {
	t[1+i] = (0,-spread) + (width/2,0)*(i-1.5);
	for (int j=0; j<4; ++j)
		t[5+4*i+j] = t[1+i] + (0,-spread) + (width/10,0)*(j-1.5);
}

tree_init(t);
vertex_size = 0.07;

for (int i=1; i<=20; ++i)
	tree_edge(i, (int)((i-1)/4));

path knife = (-10, t[5].y - 0.3) -- (10, t[5].y - 0.3);
for (int i=5; i<=20; ++i)
	for (int j=0; j<4; ++j) {
		pair d = dir(-90 + 11*(j-1.5));
		draw(firstcut(t[i] -- t[i]+d, knife).before);
	}

for (int i=0; i<=20; ++i)
	tree_node(i);

for (int i=0; i<=8; ++i) {
	pair p = t[5] - (0.4,spread) + (vertex_size*4,0)*i;
	pair q = t[20] + (0.4,-spread) - (vertex_size*4,0)*i;
	if (i < 8) {
	 	vertex(p, v_white);
		vertex(q, v_white);
	} else {
		draw(p -- q, shortdashed);
	}
}

// Vrstvy

for (int i=0; i<4; ++i) {
	pair p = (-4.3,0) - (0,spread)*(i-0.5);
	pair q = (6.7,0) - (0,spread)*(i-0.5);
	draw(p -- q, shortdashed);
}

// Tabulka

pair cols[] = {
	t[0] + (-3.8,0),
	t[0] + (3.8,0),
	t[0] + (5.0,0),
	t[0] + (6.2,0),
};

pair headrow = (0,0.8spread);
texpreamble("\font\hhh=csr8\def\hh{\hhh\vrule width 0pt depth 3pt}");
label("\hh hladina", cols[0] + headrow);
label("\hh vrcholů", cols[1] + headrow);
label("\hh velikost", cols[2] + headrow);
label("\hh celkem", cols[3] + headrow);

for (int i=0; i<3; ++i) {
	pair row = (0,-spread*i);
	label("\strut $" + (string)i + "$", cols[0] + row);
	label("\strut $" + (string)(4**i) + "$", cols[1] + row);
	label("\strut $n/" + (string)(2**i) + "$", cols[2] + row);
	label((i==0) ? "\strut $n$" : "\strut $" + (string)(2**i) + "n$", cols[3] + row);
}

pair lastrow = (0,-spread*3);
label("$\log_2 n$", cols[0] + lastrow);
label("$n^2$", cols[1] + lastrow);
label("$1$", cols[2] + lastrow);
label("$n^2$", cols[3] + lastrow);
