import ads;
import trees;

// Strom

real width = 2.5;
real spread = 1;
pair t[];
t[0] = (0,0);
for (int i=0; i<3; ++i) {
	t[1+i] = (0,-spread) + (width/2,0)*(i-1);
	for (int j=0; j<3; ++j)
		t[4+3*i+j] = t[1+i] + (0,-spread) + (width/10,0)*(j-1);
}

tree_init(t);
vertex_size = 0.07;

for (int i=1; i<=12; ++i)
	tree_edge(i, (int)((i-1)/3));

path knife = (-10, t[5].y - 0.3) -- (10, t[5].y - 0.3);
for (int i=4; i<=12; ++i)
	for (int j=0; j<3; ++j) {
		pair d = dir(-90 + 12*(j-1));
		draw(firstcut(t[i] -- t[i]+d, knife).before);
	}

for (int i=0; i<=12; ++i)
	tree_node(i);

for (int i=0; i<=5; ++i) {
	pair p = t[4] - (0.2,spread) + (vertex_size*4,0)*i;
	pair q = t[12] + (0.2,-spread) - (vertex_size*4,0)*i;
	if (i < 5) {
	 	vertex(p, v_white);
		vertex(q, v_white);
	} else {
		draw(p -- q, shortdashed);
	}
}

// Vrstvy

for (int i=0; i<4; ++i) {
	pair p = (-4,0) - (0,spread)*(i-0.5);
	pair q = (7,0) - (0,spread)*(i-0.5);
	draw(p -- q, shortdashed);
}

// Tabulka

pair cols[] = {
	t[0] + (-3.5,0),
	t[0] + (3.5,0),
	t[0] + (5.0,0),
	t[0] + (6.5,0),
};

pair headrow = (0,0.8spread);
texpreamble("\font\hhh=csr8\def\hh{\hhh\vrule width 0pt depth 3pt}");
label("\hh hladina", cols[0] + headrow);
label("\hh vrcholů", cols[1] + headrow);
label("\hh velikost", cols[2] + headrow);
label("\hh celkem", cols[3] + headrow);

for (int i=0; i<3; ++i) {
	pair row = (0,-spread*i);
	label("\strut $" + (string)i + "$", cols[0] + row);
	label("\strut $" + (string)(3**i) + "$", cols[1] + row);
	label("\strut $n/" + (string)(2**i) + "$", cols[2] + row);
	label((i==0) ? "\strut $n$" : "\strut $" + (string)(3**i) + "/" + (string)(2**i) + "\cdot n$", cols[3] + row);
}

pair lastrow = (0,-spread*3);
label("$\log_2 n$", cols[0] + lastrow);
label("$n^{\log_2 3}$", cols[1] + lastrow);
label("$1$", cols[2] + lastrow);
label("$n^{\log_2 3}$", cols[3] + lastrow);
