import ads;
unitsize(1.3cm);

// j-tý vrchol v i-té vrstvě
pair p(real i, real j) {
	return (i*1.5, j);
}

pair v[] = {
	p(0,0),					// 0 = zdroj
	p(1,0.9), p(1,0), p(1,-0.9),		// 1,2,3 = 1. vrstva
	p(2,1), p(2,0), p(2,-1),		// 4,5,6 = 2. vrstva
	p(3,1), p(3,1/3), p(3,-1/3), p(3,-1),	// 7,8,9,10 = 3. vrstva
	p(4,2/3), p(4,-2/3),			// 11,12 = 4. vrstva
	p(5,0),					// 13 = spotřebič
	p(5,4/5), p(5,-4/5),			// 14,15 = 5. vrstva
};

graph(v);

void darc(int i, int j)
{
	arc(i, j, e_smallarrow);
}

// Pruned edge
void parc(int i, int j)
{
	arc(i, j, shortdashed, e_smallarrow);
}

// Back edge
void barc(int i, int j)
{
	arc(i, j, agray, e_smallarrow);
}

darc(0, 1);
darc(0, 2);
darc(0, 3);

parc(1, 4);
darc(1, 5);
parc(2, 4);
darc(2, 6);
darc(3, 5);
darc(3, 6);

parc(4, 7);
darc(5, 8);
parc(5, 9);
darc(6, 10);

darc(8, 11);
darc(10, 12);

darc(11, 13);
darc(12, 13);
parc(11, 14);
parc(12, 15);

barc(5, 2);
barc(11, 7);
barc(11, 12);
barc(9, 3);
barc(10, 9);

void lay(int i, int j)
{
	pair top = v[i];
	pair bot = v[j];
	real w = 0.3;
	real h = 0.4;
	draw(top - (w,0) {up} .. top + (0,h) .. {down} top + (w,0) -- bot + (w,0) {down} .. bot - (0,h) .. {up} bot - (w,0) -- cycle, hair);
}

lay(0, 0);
lay(1, 3);
lay(4, 6);
lay(7, 10);
lay(11, 12);
lay(14, 15);

label("$z$", v[0], SSW);
label("$s$", v[13], SSE);
