import ads;

picture g = currentpicture;

pair z = (-2, 0);
pair lu = (-1, 1);
pair ld = (-1, -1);
pair ru = (1, 1);
pair rd = (1, -1);
pair s = (2, 0);

picture vrcholy = ads_sub_pic();
vertex(z);	label("$z$", z, W);
vertex(lu);	label("$a$", lu, 1.2*NNW);
vertex(ld);	label("$b$", ld, 1.2*SSW);
vertex(ru);	label("$c$", ru, 1.2*NNE);
vertex(rd);	label("$d$", rd, 1.2*SSE);
vertex(s);	label("$s$", s, E);

picture hrany = ads_sub_pic();
arc(z, lu, e_smallarrow);
arc(z, ld, e_smallarrow);
arc(lu, ru, e_smallarrow);
arc(lu, rd, e_smallarrow);
arc(ld, ru, e_smallarrow);
arc(ld, rd, e_smallarrow);
arc(ru, s, e_smallarrow);
arc(rd, s, e_smallarrow);

picture tok = ads_sub_pic();
add(vrcholy);
add(hrany);
label("$10/10$", .5(z+lu), NW);
label("$6/10$", .5(z+ld), SW);
label("$6/7$", .5(lu+ru), N);
label("$4/5$", interp(lu, rd, .75), NE);
label("$3/9$", interp(ld, ru, .25), NW);
label("$3/3$", .5(ld+rd), S);
label("$9/10$", .5(ru+s), NE);
label("$7/10$", .5(rd+s), SE);

void arcpair(pair x, pair y, string rxy, string ryx, real pxy=0.5, real pyx=0.5, real dxy=1.5, real dyx=1.5)
{
	pair d = unit(y-x);
	arcd(x, y, d*dir(20), d*dir(-20), e_smallarrow);
	arcd(y, x, -d*dir(20), -d*dir(-20), e_smallarrow);
	label("$" + rxy + "$", interp(x, y, pxy), dxy*d*dir(90));
	label("$" + ryx + "$", interp(y, x, pyx), -dyx*d*dir(90));
}

void markarc(pair x, pair y)
{
	pair d = unit(y-x);
	draw(x { d*dir(20) } .. y { d*dir(-20) }, gray(0.7) + roundcap + 2mm);
}

picture rezervy = ads_sub_pic();
markarc(z, ld);
markarc(ld, ru);
markarc(ru, lu);
markarc(lu, rd);
markarc(rd, s);
add(vrcholy);
arcpair(z, lu, "0", "10");
arcpair(z, ld, "4", "6");
arcpair(lu, ru, "1", "6", 0.5, 0.5, 2, 0);
arcpair(lu, rd, "1", "4", 0.8, 0.3, 1.7, 0);
arcpair(ld, ru, "6", "3", 0.2, 0.7, 1.5, 0);
arcpair(ld, rd, "0", "3", 0.5, 0.5, 0, 2);
arcpair(ru, s, "1", "9");
arcpair(rd, s, "3", "7");

currentpicture = g;
add(centered(tok), (0,0));
add(centered(rezervy), (5.5,0));
