import ads;
import circuit;

real u = 1;

pair a1[] = gand((2u, 1.5u));
pair a2[] = gand((2u, 0));
pair a3[] = gand((2u, -1.5u));
pair o1[] = gor((4u, 0.75u));
pair o2[] = gor((6u, -0.75u));

pair in[] = {
	(0, a1[2].y),
	(0, 0),
	(0, a3[1].y),
};

pair out = (7.5u, o2[0].y);

real x1 = 2/3u;
real x2 = 6/5u;

// vstup 0
dwire(in[0] -- a1[2]);
dwire((x2,in[0].y) -- (x2,a2[1].y) -- a2[1]);
conn((x2,in[0].y));

// vstup 2
dwire(in[2] -- a3[1]);
dwire((x2, in[2].y) -- (x2,a2[2].y) -- a2[2]);
conn((x2, in[2].y));

// vstup 1
pair c = (x1, in[1].y);
draw(in[1] -- c);
conn(c);
dwire(c -- (x1, a1[1].y) -- a1[1]);
dwire(c -- (x1, a3[2].y) -- a3[2]);

// výstup a1 a a2 do o1
real t0 = interp(a1[0].x, o1[1].x, 0.5);
dwire(a1[0] -- (t0, a1[0].y) -- (t0, o1[1].y) -- o1[1]);
dwire(a2[0] -- (t0, a2[0].y) -- (t0, o1[2].y) -- o1[2]);

// výstup o1 a a3 do o2
real t1 = interp(o1[0].x, o2[1].x, 0.5);
dwire(o1[0] -- (t1, o1[0].y) -- (t1, o2[1].y) -- o2[1]);
dwire(a3[0] -- (t1, a3[0].y) -- (t1, o2[2].y) -- o2[2]);

// výstup o2 na výstup sítě
dwire(o2[0] -- out - (pin_size, 0));

// Piny musíme kreslit jako poslední, ať mají prázdné vnitřky
pin(in[0]);	label("$x$", in[0], 2W);
pin(in[1]);	label("$y$", in[1], 2W);
pin(in[2]);	label("$z$", in[2], 2W);
pin(out);	label("$q$", out, 2E);

// Hranice taktů
real takty[] = {
	-u,
	1/3u,
	interp(a1[0].x, o1[1].x, 2/3),
	interp(o1[0].x, o2[1].x, 2/3),
	interp(o2[0].x, out.x, 1/3),
	8u,
};

for (int i=1; i<=4; ++i) {
	draw((takty[i], -3u) -- (takty[i], 2.5u), shortdashed);
}

for (int i=0; i<=4; ++i) {
	label("$S_" + (string)i + "$", (interp(takty[i], takty[i+1], 0.5), -2.5u));
}
