import ads;
import circuit;

picture g = currentpicture;
real u = 1;

/*** Sériový OR ***/

picture g1 = ads_sub_pic();

pair o1[] = gor((0, 3.6u));
pair o2[] = gor((0, 1.8u));
pair o3[] = gor((0, 0));

real xin = -1.5u;
pair in[] = {
	(xin, o1[1].y),
	(xin, o1[2].y),
	(xin, o2[2].y),
	(xin, o3[2].y),
};
pair out = (1.5u, o3[0].y);

dwire(in[0] -- o1[1]);
dwire(in[1] -- o1[2]);
dwire(in[2] -- o2[2]);
dwire(in[3] -- o3[2]);

real c = o1[0].x + 0.5u;
real d = o1[1].x - 0.5u;
real h1 = interp(o1[0].y, o2[0].y, 0.5);
dwire(o1[0] -- (c, o1[0].y) -- (c, h1) -- (d, h1) -- (d, o2[1].y) -- o2[1]);

real cc = c - 0.3u;
real dd = d + 0.3u;
real h2 = interp(o2[0].y, o3[0].y, 0.5);
draw(o2[0] -- (c, o2[0].y) -- (c, h2) -- (cc, h2));
draw((cc, h2) -- (dd, h2), shortdashed);
dwire((dd, h2) -- (d, h2) -- (d, o3[1].y) -- o3[1]);

dwire(o3[0] -- out - (pin_size, 0));

for (int i=0; i<4; ++i) {
	pin(in[i]);
	label("$x_" + (i==3 ? "n" : (string)(i+1)) + "$", in[i], 1.5W);
}

pin(out);
label("$y$", out, 1.5E);

/*** Paralelní OR ***/

picture g2 = ads_sub_pic();
rotate_gates = true;

// 1. vrstva
pair sin[] = new pair[8];
pair l1[][] = new pair[4][];
for (int i=0; i<4; ++i) {
	l1[i] = gor((i*1.5*u, 4u));
	sin[2*i] = (l1[i][1].x, 5u);
	sin[2*i+1] = (l1[i][2].x, 5u);
	dwire(sin[2*i] -- l1[i][1]);
	dwire(sin[2*i+1] -- l1[i][2]);
}

// 2. vrstva
pair l2[][] = new pair[2][];
for (int i=0; i<2; ++i) {
	pair a = l1[2*i][0];
	pair b = l1[2*i+1][0];
	real h = 3.3u;
	l2[i] = gor((interp(a.x, b.x, 0.5), 2.5u));
	dwire(a -- (a.x, h) -- (l2[i][1].x, h) -- l2[i][1]);
	dwire(b -- (b.x, h) -- (l2[i][2].x, h) -- l2[i][2]);
}

// 3. vrstva
pair aa = l2[0][0];
pair bb = l2[1][0];
real hh = 1.8u;
pair l3[] = gor((interp(aa.x, bb.x, 0.5), 1u));
dwire(aa -- (aa.x, hh) -- (l3[1].x, hh) -- l3[1]);
dwire(bb -- (bb.x, hh) -- (l3[2].x, hh) -- l3[2]);

// Výstup
pair sout = (l3[0].x, 0);
dwire(l3[0] -- sout + (0, pin_size));

for (int i=0; i<8; ++i) {
	pin(sin[i]);
	label("$x_" + (string)(i+1) + "$", sin[i], 2N);
}
pin(sout);
label("$y$", sout, 2S);

/*** Celek ***/

currentpicture = g;
add(centered(g1), (0, 0) * u);
add(centered(g2), (5.5, 0) * u);
