import ads;

string bb = "\font\b=csb10\b ";
int depths[] = { 4, 1, 2, 1, 3, 1, 2, 1, 4 };

pair p(real r, real c) {
	return (0.7*c, -0.4*r);
}

// Vstup
int xx[] = { 0, 1, 1, 1, 0, 1, 0, 0 };
int yy[] = { 0, 0, 1, 1, 1, 0, 1, 1 };
for (int i=0; i<8; ++i) {
	label("$" + (string)(7-i) + "$", p(0,i));
	label("\rm " + (string) xx[i], p(1,i));
	label("\rm " + (string) yy[i], p(2,i));
}

// Chování bloků
string c0 = bb + "0";
string c1 = bb + "1";
string cc = "\tt <";
string ch[][] = {
	{ c0, cc, c1, c1, cc, cc, cc, cc },
	{ c0, c1, cc, cc },
	{ c0, cc },
	{ c0 },
};
for (int b=0; b<4; ++b) {
	int bs = 2^b;
	int nb = 2^(3-b);
	for (int i=0; i<nb; ++i) {
		label(ch[b][i], p(3+b, i*bs + (bs-1)/2));
	}
}

// Vypočtené přenosy
string pr[][] = {
	{ "0", "", "", "", "", "", "", "", "0" },
	{ "", "", "", "", "0", "", "", "", "" },
	{ "", "", "1", "", "", "", "0", "", "" },
	{ "", "1", "", "1", "", "0", "", "0", "" },
};
for (int c=0; c<=8; ++c) {
	draw(p(6.5, c-0.5) -- p(11.5 - depths[c], c-0.5), shortdashed);
	draw(p(11.5 - depths[c], c-0.5) -- p(11.5, c-0.5));
}
for (int b=0; b<4; ++b) {
	for (int i=0; i<=8; ++i)
		if (pr[b][i] != "") {
			unfill(box(p(6.6+b, i-1+0.3), p(7.4+b, i-0.3)));
			label("\rm " + pr[b][i], p(7+b, i-0.5));
		}
}

// Výstup
int zz[] = { 1, 0, 1, 0, 1, 1, 1, 1 };
for (int i=0; i<8; ++i)
	label("\rm " + (string) zz[i], p(11,i));

// Vodorovné linky
for (int r=0; r<13; ++r) {
	if (r == 1 || r == 3 || r == 7 || r == 11)
		draw(p(r-0.5, -3) -- p(r-0.5, 10), shortdashed);
	if (r != 2)
		draw(p(r-0.5, -0.5) -- p(r-0.5, 7.5));
}

// Svislé linky
for (int c=0; c<=8; ++c) {
	draw(p(-0.5, c-0.5) -- p(2.5+depths[c], c-0.5));
	draw(p(10.5, c-0.5) -- p(11.5, c-0.5));
}

// Popis
void popis(real r, string s)
{
	label("\rm " + s, p(r, 8), align=RightSide);
}
popis(0, "pozice");
popis(1.5, "vstup");
popis(4.5, "bloky");
popis(8.5, "přenosy");
popis(11, "výstup");
