import ads;
import circuit;

real u = 1;

pair[] adder(pair p)
{
	real w = 1;
	real h = 1;
	draw(box(p-0.5(w,h), p+0.5(w,h)));
	label("$\sum$", p);

	pair ports[] = {
		p + (-0.25w, 0.5h),	// 0 = x
		p + (0.25w, 0.5h),	// 1 = y
		p + (-0.5w, 0),		// 2 = c_in
		p + (0.5w, 0),		// 3 = c_out
		p + (0, -0.5h),		// 4 = z
	};
	return ports;
}

pair a[][] = {
	adder((0, 0)),
	adder((2u, 0)),
	adder((4u, 0)),
	adder((7u, 0)),
};

for (int i=0; i<4; ++i) {
	pair x = a[i][0] + (0,0.6u);
	pair y = a[i][1] + (0,0.6u);
	string ii = (i == 3) ? "n" : (string) i;
	dwire(x -- a[i][0]);
	dwire(y -- a[i][1]);
	pin(x); label("$x_" + ii + "$", x, 2N);
	pin(y); label("$y_" + ii + "$", y, 2N);

	pair z = a[i][4] - (0,0.6u);
	dwire(a[i][4] -- z + (0,pin_size));
	pin(z); label("$z_" + ii + "$", z, 2S);
}

for (int i=0; i<2; ++i) {
	dwire(a[i][3] -- a[i+1][2]);
	label("$c_" + (string)(i+1) + "$", interp(a[i][3], a[i+1][2], 0.5), N);
}

pair dd = (0.6u, 0);
draw(a[2][3] -- a[2][3] + dd);
draw(a[2][3] + dd -- a[3][2] - dd, shortdashed);
dwire(a[3][2] - dd -- a[3][2]);
label("$c_3$", a[2][3] + dd/2, N);
label("$c_{n-1}$", a[3][2] - 0.8dd, N);

pair c0 = a[0][2] - (u,0);
pair cn = a[3][3] + (u,0);

dwire(c0 -- a[0][2]);
label("$0$", c0, W);
label("$c_0$", interp(c0, a[0][2], 0.5), N);

dwire(a[3][3] -- cn - (pin_size,0));
pin(cn); label("$c_n$", interp(cn, a[3][3], 0.5), N);
