import ads;

real w = 8;		// Šířka celého obrázku
real h = 3;		// Výška celého obrázku

// x-ové souřadnice důležitých bodů
real p = w/2;		// n/2
real M = 4/5 * p;	// maximum
real m = 7/8 * w;	// minimum
real n = w;		// konec

// Okraj
draw((0, h) -- (0,0) -- (w, 0) -- (w, h));

// Průběh křivky
real ym = 0.2h;
real yM = 0.9h;
real y0 = interp(ym, yM, (n-m)/(M+n-m));
real yn = y0;
real yp = interp(yM, ym, (p-M)/(m-p));

// Rozdělení na horu a údolí
pair kk = intersectionpoint((0,y0) -- (M,yM), (M-n/2,yM) -- (m-n/2, ym));
real k = kk.x;
real yk = kk.y;

draw((0,y0) -- (M,yM) -- (m,ym) -- (n,yn));

// Body a popisky

pen dd = shortdashed;

label("\strut $0$", (0,0), S);

label("\strut $k$", (k,0), S);
draw((k,0) -- (k,yk), dd);
fill(circle((k,yk), 0.05));

label("\strut\eightrm max", (M,0), S);
draw((M,0) -- (M,yM), dd);
fill(circle((M,yM), 0.05));

label("\strut ${n\over2}$", (p,0), S);
draw((p,0) -- (p,h), dd);

label("\strut ${n\over2}+k$", (p+k,0), S);
draw((p+k,0) -- (p+k,yk), dd);
fill(circle((p+k,yk), 0.05));

label("\strut\eightrm min", (m,0), S);
draw((m,0) -- (m,ym), dd);
fill(circle((m,ym), 0.05));

label("\strut $n-1$", (n,0), S);

// Stínové křivky

pen ss = linetype(new real[] { 3, 3 });
draw((k,yk) -- (m-p,ym) -- (p,yn), ss);
draw((p+k,yk) -- (p+M,yM) -- (n,yp), ss);

// Dělení na horu a údolí

draw((-0.1*w,yk) -- (1.2*w,yk), dd);
label((1.1*w,yk), "\rm hora", 2N);
label((1.1*w,yk), "\rm údolí", 2S);

// A nakonec vzpěra, ať se obrázek správně vycentruje
draw((-3, 0) -- (w+3, 0), invisible);
