import ads;
import fortune;

real sf = 12.5/1024;
transform s = shift(0,4) * scale(sf,-sf);

pair pts[] = { s*(341.333, 168.000), s*(512.000, 68.000), s*(682.667, 118.000) };
pair cc = s*(535.562, 303.847);
real cr = sf*237.021;
pair sw = s*(0, 540.869);
pair p1c = s*(341.333, 354.434);
real p1a = -0.001340954 / sf;
pair p2c = s*(512.000, 304.434);
real p2a = -0.001057376 / sf;
pair p3c = s*(682.667, 329.434);
real p3a = -0.001182400 / sf;
pair isec[] = { s*(-1125.621, -2531.237), s*(535.562, 303.847), s*(535.562, 303.847), s*(3716.556, -10553.947) };

path bbox = box((0,-2), (10,4));
//draw(bbox, dashed);

// Paraboly a kusy pobřeží
path p1 = parabola(p1c, p1a, bbox);
path p2 = parabola(p2c, p2a, bbox);
path p3 = parabola(p3c, p3a, bbox);
path b1 = firstcut(p1, p3).before;
path b2 = firstcut(p3, p1).after;

// Paraboly
draw(p1, shortdashed);
draw(p2, shortdashed);
draw(p3, shortdashed);

// Kružnice
draw(circle(cc, cr), shortdashed);

// Pobřežní linie
draw(b1);
draw(b2);

// Osy
pair c12 = interp(pts[0], pts[1], 0.5);
pair d12 = unit(pts[1] - pts[0]) * dir(-90);
path o12 = c12 - 20*d12 -- c12 + 20*d12;
path s12 = (-100, isec[1].y) -- (100, isec[1].y);
draw(firstcut(firstcut(o12, bbox).after, s12).before, thick);
draw(firstcut(lastcut(o12, bbox).before, s12).after, middashed);

pair c23 = interp(pts[1], pts[2], 0.5);
pair d23 = unit(pts[2] - pts[1]) * dir(-90);
path o23 = c23 - 20*d23 -- c23 + 20*d23;
path s23 = (-100, isec[1].y) -- (100, isec[1].y);
draw(firstcut(firstcut(o23, bbox).after, s23).before, thick);
draw(firstcut(lastcut(o23, bbox).before, s23).after, middashed);

pair c13 = interp(pts[0], pts[2], 0.5);
pair d13 = unit(pts[2] - pts[0]) * dir(-90);
path o13 = c13 - 20*d13 -- c13 + 20*d13;
path s13 = (-100, isec[1].y) -- (100, isec[1].y);
draw(firstcut(firstcut(o13, bbox).after, s13).before, middashed);
draw(firstcut(lastcut(o13, bbox).before, s13).after, thick);

// Zametací přímka
draw(sw -- sw+(10,0));
label("$p$", sw+(9.5,0), N);

// Body
epoint(pts[0]);
epoint(pts[1]);
epoint(pts[2]);
