import ads;

/* Ohackovaná verze geom-voronoi.asy */

real u = 1.2;

pair A[] = {
	(0, 0),
	(-u, -u),
	(1.3u, -u),
	(1.50821u, 0.7u),
	(0.6u, 0.8u),
	(0.2u, 1.9u),
	(-1.3u, 1u),
};

pair osa(pair a, pair b, real ang, real l)
{
	return interp(a, b, 0.5) + unit(b-a)*dir(ang)*l;
}

pair prusecik_os(pair p, pair q, pair r)
{
	path a = osa(p, q, 90, 10) -- osa(p, q, -90, 10);
	path b = osa(q, r, 90, 10) -- osa(q, r, -90, 10);
	return intersectionpoint(a, b);
}

pair B[] = {
	prusecik_os(A[0], A[1], A[2]),
	prusecik_os(A[0], A[1], A[6]),
	prusecik_os(A[0], A[4], A[6]),
	prusecik_os(A[4], A[5], A[6]),
	prusecik_os(A[3], A[4], A[5]),
	prusecik_os(A[0], A[3], A[4]),
	prusecik_os(A[0], A[2], A[4]),
};

path bb = box((-2.8,-2.5), (3.2,3));
draw(bb, shortdashed);

draw(intersectionpoint(bb, B[0] -- osa(A[1], A[2], -90, 2)) -- B[0] -- B[1] -- intersectionpoint(bb, B[1] -- osa(A[1], A[6], 90, 1.8)), halfthick);
draw(B[1] -- B[2] -- B[3] -- intersectionpoint(bb, B[3] -- osa(A[6], A[5], 90, 2)), halfthick);
draw(B[3] -- B[4] -- intersectionpoint(bb, B[4] -- osa(A[3], A[5], -90, 2.7)), halfthick);
draw(B[4] -- B[5] -- B[2], halfthick);
draw(B[5] -- B[6] -- intersectionpoint(bb, B[6] -- osa(A[2], A[3], -90, 1.8)), halfthick);
draw(B[6] -- B[0], halfthick);

for (int i=0; i<7; ++i) {
	fpoint(B[i]);
	draw((-2.8, B[i].y) -- (3.2, B[i].y), shortdashed);
}
