import ads;
unitsize(1.1cm);

pair A[], B[];
pair u = (-3, 0);
for (int i=0; i<4; ++i)
	A[i] = scale(1, 0.7) * rotate(-30*i) * u;
A[2] += (0, 0.1);
draw(A[0] -- A[1] -- A[2] -- A[3], thick);
draw(scale(1, 0.7) * (u/2 .. rotate(-30)*u/2 .. rotate(-60)*u/2 .. rotate(-90)*u/2), e_smallarrow);

B[0] = (-2, 0.5);
B[1] = (-1, 1.5);
B[2] = (-0.5, 0.2);
for (int i=0; i<3; ++i)
	fpoint(B[i]);

path ub = (-20, 3) -- (20, 3);
real ang[] = {
	90,
	degrees(A[1] - A[0]),
	degrees(A[2] - A[1]),
	degrees(A[3] - A[2]),
};
for (int i=0; i<3; ++i) {
	draw(reverse(lastcut(A[i] -- A[i] + dir(ang[i])*6, ub).before), middashed);
	real l = 1 + (i-1)*0.2;
	draw(A[i] + dir(ang[i])*l .. A[i] + dir((ang[i]+ang[i+1])/2)*l .. A[i] + dir(ang[i+1])*l, e_smallarrow);
}

for (int i=0; i<4; ++i)
	epoint(A[i]);

label(A[0], "$L$", 2W);
