import ads;

real u = 1;

pair p(real i, real j) {
	return (i*3u, (7-j)*u);
}

for (int i=0; i<8; ++i) {
	draw(p(0.05,i) -- p(3.3,i));
	label("$y_" + (string) i + "$", p(3.3,i), E);
}

void comb(real i, real j, string s)
{
	pair at = p(i,j);
	fill(circle(at, 0.2), white);
	draw(circle(at, 0.2), thin);
	label(s, at);
}

for (int pass=0; pass<2; ++pass) {
	for (int i=0; i<3; ++i) {
		real ii = i + 1;
		int blocks = 2^(2-i);
		int hsize = 2^i;
		int bsize = 2*hsize;
		int j = 0;
		for (int b=0; b<blocks; ++b) {
			for (int p=0; p<bsize; ++p) {
				if (pass == 0) {
					if (p < hsize) {
						draw(p(ii-0.6,j+hsize) -- p(ii,j), thin);
						fill(circle(p(ii-0.6,j+hsize), 0.05));
					} else {
						draw(p(ii-0.6,j-hsize) -- p(ii,j), thin);
						fill(circle(p(ii-0.6,j-hsize), 0.05));
					}
				} else {
					if (p < hsize) {
						comb(ii, j, "{\font\t=cmtt8\t +" + (string) p + "}");
					} else {
						comb(ii, j, "{\font\t=cmtt8\t -" + (string) (p-hsize) + "}");
					}
				}
				++j;
			}
		}
	}
}

void x(int i, int j, string s)
{
	label("\sevenrm " + s, p(i+0.18,j-0.18));
}

x(3,0,"000");
x(3,1,"001");
x(3,2,"010");
x(3,3,"011");
x(3,4,"100");
x(3,5,"101");
x(3,6,"110");
x(3,7,"111");

x(2,0,"000");
x(2,1,"010");
x(2,2,"100");
x(2,3,"110");
x(2,4,"001");
x(2,5,"011");
x(2,6,"101");
x(2,7,"111");

x(1,0,"000");
x(1,1,"100");
x(1,2,"010");
x(1,3,"110");
x(1,4,"001");
x(1,5,"101");
x(1,6,"011");
x(1,7,"111");

x(0,0,"000");
x(0,1,"100");
x(0,2,"010");
x(0,3,"110");
x(0,4,"001");
x(0,5,"101");
x(0,6,"011");
x(0,7,"111");

void y(int j, int x)
{
	label("$x_" + (string) x + "$", p(0.05,j), W);
}

y(0,0);
y(1,4);
y(2,2);
y(3,6);
y(4,1);
y(5,5);
y(6,3);
y(7,7);
