import ads;

struct problem {
	pair pos;
	string text;
	frame f;
	path bbox;

	void draw() {
		Label t = Label("\strut\rm " + text);
		add(this.f, t);

		add(currentpicture, this.f, this.pos);

		pair bbmin = min(this.f) - (3, 0);
		pair bbmax = max(this.f) + (3, 2);

		// CAVEAT: Tohle je zrádné: frames pracují v postscriptových souřadnicích,
		// zatímco currentpicture v uživatelských (specifikovaných pomocí unitsize()).
		// Asymptote normálně veškeré kreslení odkládá, aby mohl transformaci z uživatelských
		// souřadnic provést dodatečně, čímž se věci značně komplikují. My tu nicméně
		// spoléháme na to, že unitsize() nikdo později nezmění, takže můžeme prostě
		// aplikovat inverzní transformaci a tím bbox převést do souřadnic currentpicture.
		this.bbox = shift(this.pos) * inverse(currentpicture.scaling()) * box(bbmin, bbmax);

		draw(this.bbox);
	}
};

problem prob(pair pos, string text)
{
	problem p;
	p.pos = pos;
	p.text = text;
	return p;
}

problem pbs[] = {
	prob((0,0), "Klika"),			// 0
	prob((3,0), "3D-párování"),		// 1
	prob((0,2), "Nz.~množina"),		// 2
	prob((3,2), "3,3-SAT"),			// 3
	prob((0.4,4), "SAT"),			// 4
	prob((2.6,4), "3-SAT"),			// 5
};

for (int i=0; i<pbs.length; ++i)
	pbs[i].draw();

void arw(int i, int j, arrowbar arrow, pen pn=thin)
{
	problem p = pbs[i];
	problem q = pbs[j];
	path pq = p.pos -- q.pos;
	real pit[] = intersect(p.bbox, pq);
	real qit[] = intersect(q.bbox, pq);
	pair pi = point(pq, pit[1]);
	pair qi = point(pq, qit[1]);
	draw(pi -- qi, pn, arrow);
}

arw(4, 5, e_biarrow);
arw(2, 4, e_arrow);
arw(5, 2, e_arrow);
arw(3, 5, e_biarrow);
arw(3, 1, e_arrow);
arw(0, 2, e_biarrow);
arw(1, 4, e_arrow, shortdashed);
