import ads;

vertex_size = 0.17;

// K_{3,3}

pair a = (-4, 0);
real u = 1;
real v = 0.7;

pair k33[] = {
	a + (-u,  v),
	a + ( 0,  v),
	a + ( u,  v),
	a + (-u, -v),
	a + ( 0, -v),
	a + ( u, -v),
};

graph(k33, 1);

for (int i=0; i<3; ++i)
	for (int j=3; j<6; ++j)
		edge(i, j);

label("$a$", k33[0]);
label("$b$", k33[1]);
label("$c$", k33[2]);
label("$x$", k33[3]);
label("$y$", k33[4]);
label("$z$", k33[5]);

// Druhý graf

pair b = (0, 0);
real r = 1.5;
real a6 = 360/6;

pair x6[] = {
	b + r*dir(0*a6+90),
	b + r*dir(1*a6+90),
	b + r*dir(2*a6+90),
	b + r*dir(3*a6+90),
	b + r*dir(4*a6+90),
	b + r*dir(5*a6+90),
};

draw(circle(b, r));
labeled_graph(x6);

void bent(int i, int j)
{
	pair u = unit(x6[j] - x6[i]);
	edged(i, j, u * dir(20), u * dir(-20));
}

bent(2, 5);
bent(4, 1);
bent(0, 3);

// Třetí graf

pair c = (4, 0);

pair y6[] = {
	c + r*dir(0*a6+90),
	c + r*dir(1*a6+90),
	c + r*dir(2*a6+90),
	c + r*dir(3*a6+90),
	c + r*dir(4*a6+90),
	c + r*dir(5*a6+90),
};

labeled_graph(y6);

for (int i=0; i<6; ++i)
	edge(i, (i+1) % 6);

edge(0, 2);
edge(0, 4);
edge(2, 4);

// Izomorfismus

edged(k33[0], x6[3], dir(-150), dir(40), middashed);
edged(k33[1], x6[5], dir(50), dir(-70), middashed);
edged(k33[2], x6[1], dir(30), dir(-30), middashed);
edged(k33[3], x6[4], dir(-40), dir(120), middashed);
edged(k33[4], x6[2], dir(-45), dir(45), middashed);
edged(k33[5], x6[0], dir(30), dir(-40), middashed);
