import ads;
import graph;

real sf = 0.3;		// Vertical scaling factor

real sk(real x, int k)
{
	return sin(2*3.141592*x*k) * sf;
}

real ck(real x, int k)
{
	return cos(2*3.141592*x*k) * sf;
}

void samples(pair pos, real func(real x), string l1, string l2) {
	picture ps;
	size(ps, 60);

	draw(ps, graph(ps, func, 0, 1, 50));
	xaxis(ps, xmin=0, xmax=1, p=hair, Ticks(ticklabel = new string(real x) { return ""; }, N=8, Size=1, hair));

	for (int i=0; i<=8; ++i) {
		real x = i/8;
		real y = func(x);
		draw(ps, (x,0) -- (x,y), Dotted(hair));
		if (i == 8) {
			unfill(ps, circle((x,y), 0.02));
			draw(ps, circle((x,y), 0.02));
		} else {
			fill(ps, circle((x,y), 0.02));
		}
	}

	label(ps, "${\bf " + l1 + "}^" + l2 + "$", (0.5, -0.5));

	add(centered(ps), pos);
}

samples((3,2.5), new real(real x) { return sk(x,2); }, "s", "2");
