import ads;

real first = 0.1mm;
real last = 0.6mm;
int steps = 6;

pair q(int i)
{
	return dir(360/(real)(steps+1)*i);
}

for (int i=0; i<=steps; ++i) {
	for (int j=i+1; j<=steps; ++j) {
		real wi = interp(first, last, (real)i/steps);
		real wj = interp(first, last, (real)j/steps);
		pen pi = black + roundcap + wi;
		pen pj = black + roundcap + wj;
		pair xi = q(i)*3;
		pair xj = q(j)*3;
		pair xh = interp(xi, xj, 0.5);
		draw(xi -- xh, pi);
		draw(xj -- xh, pj);
	}
}

for (int i=0; i<=steps; ++i) {
	real w = interp(first, last, (real)i/steps);
	real mm = w / 1mm;
	pen p = black + roundcap + w;
	filldraw(circle(q(i) * 3, 0.2), white, p);
	label("\sevenrm " + format("%.2g", mm), q(i)*3.4, q(i));
}
