import ads;

real pin_size = 0.08;

void pin(pair p)
{
	unfill(circle(p, pin_size));
	draw(circle(p, pin_size));
}

real gate_scale = 1;
bool rotate_gates = false;

// Vrací pole souřadnic portů: port 0 je výstup, ostatní jsou vstupy
pair [] gate2(pair p, string name)
{
	if (rotate_gates) {
		real h = 0.8 * gate_scale;
		real w = 1 * gate_scale;
		draw(box(p-0.5(w,h), p+0.5(w,h)));
		label("$" + name + "$", p);

		pair ports[] = {
			p + (0, -h/2),
			p + (-0.3 * w, h/2),
			p + (0.3 * w, h/2),
		};
		return ports;
	} else {
		real w = 0.8 * gate_scale;
		real h = 1 * gate_scale;
		draw(box(p-0.5(w,h), p+0.5(w,h)));
		label("$" + name + "$", p);

		pair ports[] = {
			p + (w/2, 0),
			p + (-w/2, 1/4 * h),
			p + (-w/2, -1/4 * h),
		};
		return ports;
	}
}

pair [] gate1(pair p, string name)
{
	if (rotate_gates) {
		real h = 0.8 * gate_scale;
		real w = 1 * gate_scale;
		draw(box(p-0.5(w,h), p+0.5(w,h)));
		label("$" + name + "$", p);

		pair ports[] = {
			p + (0, -h/2),
			p + (0, h/2),
		};
		return ports;
	} else {
		real w = 0.8 * gate_scale;
		real h = 1 * gate_scale;
		draw(box(p-0.5(w,h), p+0.5(w,h)));
		label("$" + name + "$", p);

		pair ports[] = {
			p + (w/2, 0),
			p + (-w/2, 0),
		};
		return ports;
	}
}

pair [] gand(pair p)
{
	return gate2(p, "\land");
}

pair [] gor(pair p)
{
	return gate2(p, "\lor");
}

pair [] gnot(pair p)
{
	return gate1(p, "\lnot");
}

void conn(pair p)
{
	fill(circle(p, 0.05));
}

void dwire(guide g)
{
	draw(g, e_smallarrow);
}
